{-# LANGUAGE FunctionalDependencies #-}
module Types.Functions
  ( IsFunction(..)
  , IsFunctionIO(..)
  ) where

import Types.Value (Valuable)

class (Show f, Valuable a, Valuable b) => IsFunction f a b | f -> a b where
  evalFunction :: f -> a -> b

class (Show f, Valuable a, Valuable b) => IsFunctionIO f a b | f -> a b where
  evalFunctionIO :: f -> a -> IO b
  functionIOTouchesFilesystem :: f -> Bool
